% Tests the compute gradient function from Acoustic1DOpt
order = 4;
opts = struct;
opts.pertSize = 5e8;
opts.xlen = 11;
opts.lim = {0,1000};
[par, truePar] = pars.kInversionPars(opts);

% Get true data
dt = 1.5e-04;
trueObj = Acoustic1DOpt(truePar, {'K'}, order, dt);
trueObj.runForward(false)

pertObj = Acoustic1DOpt(par, {'K'}, order, dt);
pertObj.setReceiverData(trueObj.forwardReceiverRecordings);

gradK = pertObj.computeGradient();
gradFDK = pertObj.computeGradientFD(0.001);

figure(1);
pertObj.plotPReceiverSignals()

figure(2);
plot(pertObj.x_primal,gradK{1});
hold on;
plot(pertObj.x_primal,gradFDK{1});