% Tests the compute gradient function from Acoustic1DOpt
order = 4;
opts = struct;
opts.xlen = 11;
opts.lim = {0,1000};
[par, truePar] = pars.rhoInversionPars(opts);

% Get true data
dt = 1.5e-04;
trueObj = Acoustic1DOpt(truePar, {'rho'}, order, dt);
trueObj.runForward(false)

pertObj = Acoustic1DOpt(par, {'rho'}, order, dt);
pertObj.setReceiverData(trueObj.forwardReceiverRecordings);

gradrho = pertObj.computeGradient();
gradFDrho = pertObj.computeGradientFD(0.001);

figure(1);
pertObj.plotPReceiverSignals()

figure(2);
plot(pertObj.x_dual,gradrho{1});
hold on;
plot(pertObj.x_dual,gradFDrho{1});
